-- Character glance stuff backported to/remade in srb2kart
-- by default, expect desyncs with some of the code, though I've tested as thoroughly as I could with local hosting, and haven't found any sync hiccups
-- have fun
-- -Anon
local FRACUNIT = FRACUNIT
local ANGLE_90 = ANGLE_90
local canglancetics = TICRATE * 3
local BACKVIEWANG = 120
local BT_LOOKBACK = BT_LOOKBACK

-- The glancechars rawset has been moved to Glance_Defines.

-- for the sake of any potential performance issues, glancing can be toggled due to its need to cycle through players
local cv_glance = CV_RegisterVar({
	name = "glancing",
	defaultvalue = "On",
	possiblevalue = CV_OnOff,
})

local left_glances = {
	U,  // 0
	V,  // 1
	U,  // 2
	V,  // 3
	U,  // 4
	V,  // 5
	28, // 6
	28, // 7
	28, // 8
	32, // 9
	32, // 10
	32  // 11
}

local left_looks = {
	Y, // 0
	Z, // 1
	Y, // 2
	Z, // 3
	Y, // 4
	Z, // 5
	30,// 6
	30,// 7
	30,// 8
	33,// 9
	33,// 10
	33 // 11
}

local right_glances = {
	W, // 0
	X, // 1
	W, // 2
	X, // 3
	W, // 4
	X, // 5
	29,// 6
	29,// 7
	29,// 8
	34,// 9
	34,// 10
	34 // 11
}

local right_looks = {
	26, // 0
	27, // 1
	26, // 2
	27, // 3
	26, // 4
	27, // 5
	31, // 6
	31, // 7
	31, // 8
	35, // 9
	35, // 10
	35  // 11
}

local function sign(x)
	return ((x < 0) and -1 or ((x > 0) and 1 or 0))
end

-- copied from MK64 cast
local camx = {}
local camy = {}

hud.add(function(v, player, cam)
	local i = cam.pnum - 1
	
	camx[i] = cam.x
	camy[i] = cam.y
end)

local function check_display_player(p)
    if p == consoleplayer then return 0 end
	
	for i = 1, 3 do
        if displayplayers[i] == p then
            return i
        end
    end

    return -1
end

-- PlayerSpawn function. Resets a couple necessary variables.
local function glanceLua_PlayerSpawnHook(p)
	p.glance_aizdriftturn = 0
	p.glance_dir = 0 -- 1.3.3: Doing this instead of fucking with the nil-safety.
end

-- we don't have access to a rearview check in lua, so we cheat by assuming the camera's in "rearview" mode if it faces the other way
-- Anon: I'm from the future. Neptune now has BT_LOOKBACK.
local function check_rear_view(p)
	if BT_LOOKBACK ~= nil then -- Hacky check to see if we're playing with a client with BT_LOOKBACK in the first place.
		return p.cmd.buttons & BT_LOOKBACK
	end

	-- Reset every time
	p.glance_lookbacksynch = false

	-- If we don't have BT_LOOKBACK, run the usual rearview cheat.
    --in a rather expected way, this cheat breaks in replays, so this is a bandaid
	if p.exiting or replayplayback or not p.mo then
		return false
	end

	local disp = check_display_player(p)

	if disp < 0 then
		-- For non display players, we can check the bit that is used to synch glance
		return p.cmd.buttons & BT_LOOKBACKSYNCH
	end

	if camx[disp] == nil or camy[disp] == nil then
		return false
	end

	local camang = R_PointToAngle2(camx[disp], camy[disp], p.mo.x, p.mo.y)

	local camdiff = abs((p.mo.angle - camang) / ANG1)

	if camdiff >= BACKVIEWANG then -- very generous grace value here
		p.glance_lookbacksynch = true
		return true
	end
end

local function HandleGlancing(p)
	p.frameangmem = p.frameangle

	local turndir = p.cmd.driftturn
	local drift = p.kartstuff[k_drift]
	local aizdrift = p.kartstuff[k_aizdriftstrat]
	local destGlanceDir = 0
	local lookback = (p.cmd.forwardmove < 0) or check_rear_view(p)
	local forcelook = false
	local currframe = (p.mo.frame - A) & 255 -- trim off any extra flags

	-- (change this if this conflicts with mods)
	-- make EVERYONE know you're looking
	if p.cmd.buttons & BT_CUSTOM1 then
		forcelook = true
	end

	if lookback and (drift == 0) then
		turndir = 0
	end

	local validsliptide = aizdrift and (not drift) and P_IsObjectOnGround(p.mo)

	if aizdrift then
		drift = sign(aizdrift)
		turndir = 0
	elseif turndir == 0 and drift == 0 then
		-- Only try glancing if you're driving straight.
		-- This avoids all-players loops when we don't need it.
		destGlanceDir = K_GlanceAtPlayers(p)

		if lookback then
			if destGlanceDir == 0 then
				if p.glance_dir ~= 0 then
					-- Keep to the side you were already on.
					if p.glance_dir < 0 then
						destGlanceDir = -1
					else
						destGlanceDir = 1
					end
				else
					-- Look to your right by default
					destGlanceDir = -1
				end
			else
				-- Looking back AND glancing? Amplify the look!
				destGlanceDir = $ * 2
			end
		end

		if forcelook and destGlanceDir ~= 0 then
			destGlanceDir = $ * 2
		end
	end

	-- Sliptide turning + glancing.
	if validsliptide then
		if abs(p.glance_aizdriftturn) < ANGLE_112h then
			p.glance_aizdriftturn = (abs(p.glance_aizdriftturn) + ANGLE_11hh)*aizdrift
		end

		-- Sliptides: drift -> lookback frames
		if abs(p.glance_aizdriftturn) >= ANGLE_90 then
			destGlanceDir = -2*sign(p.glance_aizdriftturn)
			p.glance_dir = destGlanceDir
		elseif p.glance_aizdriftturn then
			destGlanceDir = -sign(p.glance_aizdriftturn)
		end
	else
		p.glance_aizdriftturn = $ - (p.glance_aizdriftturn / 4)

		if abs(p.glance_aizdriftturn) < ANGLE_11hh then
			p.glance_aizdriftturn = 0
		end
	end

	if currframe < 12 then
		if p.glance_dir < 0 then
			if p.glance_dir < -1 then
				p.mo.frame = right_looks[currframe + 1]
			else
				p.mo.frame = right_glances[currframe + 1]
			end
		elseif p.glance_dir > 1 then
			p.mo.frame = left_looks[currframe + 1]
		elseif p.glance_dir > 0 then
			p.mo.frame = left_glances[currframe + 1]
		end
	end

	-- Update your glance value to smooth it out.
	if p.glance_dir > destGlanceDir then
		p.glance_dir = $ - 1
	elseif p.glance_dir < destGlanceDir then
		p.glance_dir = $ + 1
	end

	-- Handle sliptide turning.
	p.frameangle = $ + p.glance_aizdriftturn
	
	if p.mo.rollangle ~= nil then
		if p.glance_aizdriftturn ~= 0 then
			p.mo.rollangle = 2*(p.mo.sloperoll + p.sliproll)
		else
			p.mo.rollangle = 0
		end
	end
end

addHook("ThinkFrame", do
	if cv_glance.value == 0 then return end -- Glancing is turned off.
	
	if leveltime < canglancetics then
		return
	end

	for p in players.iterate do
		if not p.mo then continue end
		if not IsGlanceSkin(p.mo.skin) then continue end
		
		if not p.glancecharsnotif and leveltime > 235 then
			chatprintf(p, "When glancing at other players, hit Custom 1 to stare them down!")
			p.glancecharsnotif = true
		end

		HandleGlancing(p)
	end
end)

addHook("PreThinkFrame", do
	if cv_glance.value == 0 then return end -- 	Glancing is turned off.

	for p in players.iterate do
		if p.frameangmem ~= nil then
			p.frameangle = p.frameangmem -- Reset frameangle.
			p.frameangmem = nil
		end
	end
end)

addHook("PlayerSpawn", glanceLua_PlayerSpawnHook)